#include "huc.h"

#include "cd_engine.c"
#include "timer.c"

#incchr(cd_font,     "cd_font.pcx",64, 2);
#incpal(cd_font_pal, "cd_font.pcx");

char cur_com,
     type,
     joyinfo[2];

main()
{
  char i;

  set_bgpal(15,cd_font_pal);
  set_font_pal(15);
  load_font(cd_font,128,0x1000);

  cd_init();
  /*debug_info();*/

  for(;;)
  {
    joyinfo[1]=joyinfo[0];
    joyinfo[0]=joy(0);

    put_number(track_true_num[current_track],2,17,5);
    if(track_true_num[current_track]<10){put_number(0,1,17,5);}

    if(cd_status==2)
    {
      put_number(timer_mm(),2,12,7);
      put_number(timer_ss(),2,15,7);
      if(timer_mm()<10){put_number(0,1,12,7);}
      if(timer_ss()<10){put_number(0,1,15,7);}

      cd_play(type);
    }
    else if(cd_status==1)
    {
      put_number(time[0],2,12,7);
      put_number(time[1],2,15,7);
      if(time[0]<10){put_number(0,1,12,7);}
      if(time[1]<10){put_number(0,1,15,7);}
    }
    else{put_string("00:00",12,7);}

    if(joyinfo[0]!=joyinfo[1])
    {
      if(joyinfo[0]&0x80 && cur_com> 0 && cur_com<=8){cur_com--;}
      if(joyinfo[0]&0x20 && cur_com>=0 && cur_com< 8){cur_com++;}
      graphic_update();

      if(joyinfo[0]&0x01){exec_command();}
    }
    vsync(1);
  }
}

cd_init()
{
  cls();
  cd_track_times();
  timer_reset();
  cur_com=4;
  cd_status=0;
  current_track=1;
  type = CDPLAY_NORMAL;

  graphic_update();
  put_string("Track:",10,5);
  put_char(':',14,7);
}

graphic_update()
{
  put_char('A'+64,6,9);
  put_char('C'+64,8,9);
  put_char('G'+64,10,9);
  put_char('E'+64,12,9);
  put_char('F'+64,14,9);
  put_char('D'+64,16,9);
  put_char('B'+64,18,9);
  put_char('J'+64,20,9);

  if(type==CDPLAY_NORMAL){put_char('K'+64,22,9);}
  if(type==CDPLAY_RANDOM){put_char('L'+64,22,9);}

  put_string("                  ",6,10);
  put_char('H'+64,6+(cur_com<<1),10);
}

exec_command()
{
  switch(cur_com)
  {
    case 0:
      if(current_track>1){current_track--;}
      else{current_track=playable_tracks;}
      if(cd_status==2){cd_direct_play(type);}
      else{cd_status=0;cd_reset();}
      break;

    case 1:
      skip(0,-5,type);
      break;

    case 2:
      cd_status=0;
      cd_reset();
      break;

    case 3:
      if(cd_status==2)/*if playing*/
      {cd_pause();timer_pause();cd_status=1;}/*pause playing*/
      else if(cd_status==1){cd_unpause();timer_unpause();cd_status=2;}/*unpause*/
      break;

    case 4:
      cd_status=2;
      cd_direct_play(type);
      break;

    case 5:
      skip(0,5,type);
      break;

    case 6:
      if(current_track<playable_tracks){current_track++;}
      else{current_track=1;}
      if(cd_status==2){cd_direct_play(type);}
      else{cd_status=0;cd_reset();}
      break;

    case 7:
      cls();
      change_cd(1);
      cd_init();
      break;

    case 8:
      if(type==CDPLAY_NORMAL){type=CDPLAY_RANDOM;}
      else if(type==CDPLAY_RANDOM){type=CDPLAY_NORMAL;}
      break;
  }
}

debug_info()
{
  char i;

  put_string("playable tracks:",0,4);
  put_number(playable_tracks,3,18,4);

  put_string("trk   min   sec",0,6);

  for(i=1;i<=playable_tracks;++i)
  {
    put_number(track_true_num[i],3, 0,6+i);
    put_number(track_time_min[i],3, 6,6+i);
    put_number(track_time_sec[i],3,12,6+i);
  }
}
